/* $VER: translate.c 2.1 (05.06.94)
 */

#include "global.h"

/**********************************************************************
 *               Translating ISO-Latin1 -> LaTeX code                 *
 **********************************************************************/
char *translate_to_latex(const char *input)
{
	static char output[512];
	int i = 0, pos = 0;

	while (input[i])
	{
		switch (input[i])
		{
			case '-':
				output[pos++] = '-';
				output[pos++] = '-';
				break;
			case '#':
				output[pos++] = '\\';
				output[pos++] = '#';
				break;
			case '$':
				output[pos++] = '\\';
				output[pos++] = '$';
				break;
			case '%':
				output[pos++] = '\\';
				output[pos++] = '%';
				break;
			case '&':
				output[pos++] = '\\';
				output[pos++] = '&';
				break;
			case '[':
				output[pos++] = '$';
				output[pos++] = '[';
				output[pos++] = '$';
				break;
			case '\\':
				strcpy(&output[pos], "$\\backslash$");
				pos += 12;
				break;
			case ']':
				output[pos++] = '$';
				output[pos++] = ']';
				output[pos++] = '$';
				break;
			case '':
				output[pos++] = '!';
				output[pos++] = '`';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = 'i';
				output[pos++] = 't';
				output[pos++] = '\\';
				output[pos++] = '$';
				break;
			case '':
				output[pos++] = '{';
				output[pos++] = '\\';
				output[pos++] = 'S';
				output[pos++] = '}';
				break;
			case '':
				output[pos++] = '?';
				output[pos++] = '`';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '`';
				output[pos++] = 'A';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '\'';
				output[pos++] = 'A';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '^';
				output[pos++] = 'A';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '~';
				output[pos++] = 'A';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '"';
				output[pos++] = 'A';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = 'A';
				output[pos++] = 'A';
				output[pos++] = '{';
				output[pos++] = '}';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = 'A';
				output[pos++] = 'E';
				output[pos++] = '{';
				output[pos++] = '}';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = 'c';
				output[pos++] = ' ';
				output[pos++] = 'C';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '`';
				output[pos++] = 'E';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '\'';
				output[pos++] = 'E';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '^';
				output[pos++] = 'E';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '"';
				output[pos++] = 'E';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '`';
				output[pos++] = 'I';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '\'';
				output[pos++] = 'I';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '^';
				output[pos++] = 'I';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '"';
				output[pos++] = 'I';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '~';
				output[pos++] = 'N';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '`';
				output[pos++] = 'O';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '\'';
				output[pos++] = 'O';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '~';
				output[pos++] = 'O';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '"';
				output[pos++] = 'O';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '^';
				output[pos++] = 'O';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = 'O';
				output[pos++] = '{';
				output[pos++] = '}';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '`';
				output[pos++] = 'U';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '\'';
				output[pos++] = 'U';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '^';
				output[pos++] = 'U';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '"';
				output[pos++] = 'U';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '\'';
				output[pos++] = 'Y';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = 's';
				output[pos++] = 's';
				output[pos++] = '{';
				output[pos++] = '}';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '`';
				output[pos++] = 'a';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '\'';
				output[pos++] = 'a';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '^';
				output[pos++] = 'a';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '~';
				output[pos++] = 'a';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '"';
				output[pos++] = 'a';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = 'a';
				output[pos++] = 'a';
				output[pos++] = '{';
				output[pos++] = '}';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = 'a';
				output[pos++] = 'e';
				output[pos++] = '{';
				output[pos++] = '}';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = 'c';
				output[pos++] = ' ';
				output[pos++] = 'c';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '`';
				output[pos++] = 'e';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '\'';
				output[pos++] = 'e';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '^';
				output[pos++] = 'e';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '"';
				output[pos++] = 'e';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '`';
				output[pos++] = '\\';
				output[pos++] = 'i';
				output[pos++] = '{';
				output[pos++] = '}';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '\'';
				output[pos++] = '\\';
				output[pos++] = 'i';
				output[pos++] = '{';
				output[pos++] = '}';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '^';
				output[pos++] = '\\';
				output[pos++] = 'i';
				output[pos++] = '{';
				output[pos++] = '}';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '"';
				output[pos++] = '\\';
				output[pos++] = 'i';
				output[pos++] = '{';
				output[pos++] = '}';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '~';
				output[pos++] = 'n';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '`';
				output[pos++] = 'o';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '\'';
				output[pos++] = 'o';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '^';
				output[pos++] = 'o';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '~';
				output[pos++] = 'o';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '"';
				output[pos++] = 'o';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = 'o';
				output[pos++] = '{';
				output[pos++] = '}';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '`';
				output[pos++] = 'u';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '\'';
				output[pos++] = 'u';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '^';
				output[pos++] = 'u';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '"';
				output[pos++] = 'u';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '\'';
				output[pos++] = 'y';
				break;
			case '':
				output[pos++] = '\\';
				output[pos++] = '"';
				output[pos++] = 'y';
				break;
			default:
				output[pos++] = input[i];
				break;
		}
		i++;
	}
	output[pos] = '\0';

	return output;
}
